#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "worker4xi.py">
#<abstract4xi abstract = "provides function worker4xi"/>
#<refer4xi reference = "pool.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'worker4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import collections                 
    import itertools
    import queue
    import time         
except:
    pass
try:                 # rare ones
    pass          
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            

#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.pool import worker
except:
    print("worker4xi.py *** failed in from multiprocessing.pool import worker ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from maybeencodingerror4xi import MaybeEncodingError4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>


   
# -------------------------------------------------------------------------------------------------
#<function4xi function = "worker4xi" usage = "
#
#   pool.py:
#       Pool
#           _repopulate_pool
#               w = self.Process(target=worker, args=(self._inqueue, self._outqueue, self._initializer, self._initargs, self._maxtasksperchild))
#   pool4xi.py:
#       Pool4Xi
#           _repopulate_pool
#               worker2xi = self.Process(target=worker4xi, args=(self._inqueue, self._outqueue, self._initializer, self._initargs, self._maxtasksperchild))
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def worker4xi(inqueue, outqueue, initializer=None, initargs=(), maxtasks=None):
    #------------------------------------------------------------------------------------------
    # (Step 1/11)
    #------------------------------------------------------------------------------------------ 
   
    class2print = "worker4xi"
    method2print = "worker4xi"
    
    message2print = "{(Step 1a/11) started" + "; worker4xi-started: " + str(worker4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # <function worker4xi at 0x0000000003C4CE18>; time: 05:03:43 01/17/13 Pacific Standard Time
            
    message2print = "{(Step 1b/11) passed" + "; inqueue-passed-to-worker4xi: " + str(inqueue) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # <simplequeue4xi.SimpleQueue4Xi object at 0x00000000039397F0>
                
    message2print = "{(Step 1c/11) passed" + "; outqueue-passed-to-worker4xi: " + str(outqueue) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # <simplequeue4xi.SimpleQueue4Xi object at 0x0000000003939CC0> 
             
    message2print = "{(Step 1d/11) passed" + "; initializer-passed-to-worker4xi: " + str(initializer) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # None
            
    message2print = "{(Step 1e/11) passed" + "; initargs-passed-to-worker4xi: " + str(initargs) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # ()
    
    message2print = "{(Step 1f/11) passed" + "; maxtasks-passed-to-worker4xi: " + str(maxtasks) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # None
    
    #------------------------------------------------------------------------------------------
    # JUST DO IT!
    #------------------------------------------------------------------------------------------    
    if maxtasks is None:
        pass                                                                                                        # just do them!
    else:
        maxtasks = int(maxtasks)                                                                                    # accept!
        if maxtasks == 0:
            maxtasks = 33                                                                                           # always do!
        else:
            pass
        if maxtasks < 0:  
            maxtasks = abs(maxtasks)                                                                                # always do!
        else:
            pass    
    #------------------------------------------------------------------------------------------
    # (Step 2/11) - PUT QUEUE
    #------------------------------------------------------------------------------------------    
    ack2put = False
    nack2put = True
    try:
    
        put2xi = outqueue.put
        
        message2print = "{(Step 2a/11) set" + "; put2xi-set-by-worker4xi to: " + str(put2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # <bound method PipeConnection4Xi.send of <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003939D68>>
        
        ack2put = True
        
        message2print = "{(Step 2b/11) set" + "; ack2put-set-by-worker4xi to: " + str(ack2put)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # True
        
    except:
        message2print = "{(Step 2c/11) yielded" + "; nack2put-yielded-by-worker4xi: " + str(nack2put)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
                
    
    #------------------------------------------------------------------------------------------
    # (Step 3/11) - GET QUEUE
    #------------------------------------------------------------------------------------------     
    ack2get = False
    nack2get = True
    try:
        get2xi = inqueue.get
        
        message2print = "{(Step 3a/11) set" + "; get2xi-set-by-worker4xi to: " + str(get2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # <function SimpleQueue4Xi._make_methods.<locals>.get at 0x0000000003916D90>
        
        ack2get = True

        message2print = "{(Step 3b/11) set" + "; ack2get-set-by-worker4xi to: " + str(ack2get)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # True
               
    except:
        message2print = "{(Step 3z/11) yielded" + "; nack2get-yielded-by-worker4xi: " + str(nack2get)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
    
        
    #------------------------------------------------------------------------------------------
    # (Step 4/11) - CLOSE POSSIBLE WRITE AND READER
    #------------------------------------------------------------------------------------------     
    if hasattr(inqueue, '_writer'):

        try:
            ack2close = False
            nack2close = True
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------         
              
            inqueue._writer.close()
            
            message2print = "{(Step 4a/11) performed" + "; inqueue-writer-close-performed-by-worker4xi: " + str(inqueue._writer.close) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # <bound method PipeConnection4Xi.close of <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003939AC8>>        
            
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------         
            
            outqueue._reader.close()
            
            message2print = "{(Step 4b/11) performed" + "; outqueue-reader-close-performed-by-worker4xi: " + str(outqueue._reader.close) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # <bound method PipeConnection4Xi.close of <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003939CF8>>
               
            ack2close = True
            
            message2print = "{(Step 4c/11) set" + "; ack2close-set-by-worker4xi to: " + str(ack2close)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # True
            
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------         
        except:
            message2print = "{(Step 4z/11) yielded" + "; nack2close-yielded-by-worker4xi: " + str(nack2close)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
    

    
    #------------------------------------------------------------------------------------------
    # (Step 5/11)- INITIALIZE IF NECESSARY
    #------------------------------------------------------------------------------------------
    if initializer is not None: # given as a parameter to worker
        ack2init = False
        nack2init = True
        try:
         
            initializer(*initargs)
    
            message2print = "{(Step 5a/11) performed" + "; initializer-performed-by-worker4xi: " + str(initializer) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            
            ack2init = True
            
            message2print = "{(Step 5b/11) set" + "; ack2init-set-by-worker4xi to: " + str(ack2init)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            
        except:
            message2print = "{(Step 5z/11) yielded" + "; nack2init-yielded-by-worker4xi: " + str(nack2init)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
                          
    
    #------------------------------------------------------------------------------------------
    # (Step 6/11) - DO IT!
    #------------------------------------------------------------------------------------------
    ack2while = False
    completed2xi = 0                                                                                                # no trials so far
                                  
    if ((ack2put is True) and (ack2get is True)):                                                                   # required queues exist
        while maxtasks is None or (maxtasks and completedxi < maxtasks):  
            ack2while = True
            
            #--------------------------------------------------------------------------------------
            # 
            #--------------------------------------------------------------------------------------
            ack2task = False
            nack2task = True
            try:
                
                # ---------------------------------------------------------------------------------    
                # GET TASK FROM QUEUE   
                # ---------------------------------------------------------------------------------         
                
                message2print = "{(Step 6a/11) calling" + "; get2xi-calling-by-worker4xi: " + str(get2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)       
                # <function SimpleQueue4Xi._make_methods.<locals>.get at 0x0000000003916D90>     
            
                task2xi = get2xi()
                
                message2print = "{(Step 6b/11) performed" + "; get2xi-performed-by-worker4xi: " + str(get2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                # <function SimpleQueue4Xi._make_methods.<locals>.get at 0x0000000003916D90>
                
                message2print = "{(Step 6c/11) got" + "; task2xi-got-by-worker4xi: " + str(task2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # None <-- *** over 30 many times ***  <-- JATKA             

            except (EOFError, IOError):
  
                # got EOFError or IOError -- exiting
    
                message2print = "{(Step 6z/11) yielded" + "; EOFError-or-IOError-yielded-by-worker4xi: " + " got EOFError or IOError - exiting " + str(get2xi)  + " *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                break

            # -------------------------------------------------------------------------------------    
            # (Step 7/11)
            # -------------------------------------------------------------------------------------         
            if task2xi is None:
                # worker got sentinel -- exiting
                
                message2print = "{(Step 7z/11) yielded" + "; task2xi-yielded-by-worker4xi: " + str(task2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # 05:36:05 01/17/13 Pacific Standard Time
                
                break
    
            # -------------------------------------------------------------------------------------    
            # (Step 8/11) - GET THE JOB
            # -------------------------------------------------------------------------------------         
            ack2job = False
            ack2func = False
            nack2job = True
            nack2func = True
            job2xi = None
            i2xi  = None
            func2xi = None
            args  = None
            kwds = None 
            
            message2print = "{(Step 8a/11) using" + "; task2xi-using-by-worker4xi to: " + str(task2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            #         
            try:

                # =========================================
                job2xi, i2xi, func2xi, args, kwds = task2xi
                # =========================================
                
                message2print = "{(Step 8b/11) set" + "; job2xi-set-by-worker4xi to: " + str(job2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 8c/11) set" + "; i2xi-set-by-worker4xi to: " + str(i2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 8d/11) set" + "; func2xi-set-by-worker4xi to: " + str(func2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 8e/11) set" + "; args-set-by-worker4xi to: " + str(args)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                                 
                
                message2print = "{(Step 8f/11) set" + "; kwds-set-by-worker4xi to: " + str(kwds)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                ack2job = True
                
                message2print = "{(Step 8g/11) set" + "; ack2job-set-by-worker4xi to: " + str(ack2job)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
                # 
                
                ack2func = True
                
                message2print = "{(Step 8h/11) set" + "; ack2func-set-by-worker4xi to: " + str(ack2func)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                   
                # 
            except:
                message2print = "{(Step 8z1/11) yielded" + "; nack2job-yielded-by-worker4xi: " + str(nack2job)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # 
                message2print = "{(Step 8z2/11) yielded" + "; nack2func-yielded-by-worker4xi: " + str(nack2func)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                # 
                
            # -------------------------------------------------------------------------------------    
            # (Step 9/11) - GET RESULT
            # -------------------------------------------------------------------------------------         
            ack2result = False
            nack2result = True
            
            result2xi = None 
            if ack2func is True:
                try:
                    # ========================================
                    result2xi = (True, func2xi(*args, **kwds))
                    # ========================================
                    
                    message2print = "{(Step 9c/11) set" + "; result2xi-set-by-worker4xi to: " + str(result2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # 
                    
                    ack2result = True
                    
                    message2print = "{(Step 9d/11) set" + "; ack2result-set-by-worker4xi to: " + str(ack2result)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    # 
                                     
                except Exception as e:
                
                    message2print = "{(Step 9z1/11) hit" + "; Exception-hit-by-worker4xi: " + " *** " + str(e)  + " *** " + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                                   
                    result2xi = (False, e)
                    
                    
                    message2print = "{(Step 9z2/11) set" + "; result2xi-set-by-worker4xi to: " + str(result2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                    
                    message2print = "{(Step 9z3/11) yielded" + "; nack2result-yielded-by-worker4xi: " + str(nack2result)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # 
                      
            else:
                message2print = "{(Step 9z4/11) yielded" + "; nack2result-yielded-by-worker4xi: " + str(nack2result)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
                #                   
    
            # -------------------------------------------------------------------------------------    
            # (Step 10/11) - PUT JOB. INDEX AND RESULT
            # -------------------------------------------------------------------------------------         
            if ((ack2put is True) and (ack2job is True) and (ack2result is True)):
            
                message2print = "{(Step 10a/11) passing" + "; job2xi-passing-to-put2xi-by-worker4xi: " + str(job2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
                # 
                
                message2print = "{(Step 10b/11) passing" + "; index-passing-to-put2xi-by-worker4xi: " + str(i2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
                # 
                
                message2print = "{(Step 10c/11) passing" + "; result2xi-passing-to-put2xi-by-worker4xi: " + str(result2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
                #               
                try:
                
                    # ===============================
                    put2xi((job2xi, i2xi, result2xi))
                    # ===============================
            
                    message2print = "{(Step 10d1/11) performed" + "; put2xi-performed-by-worker4xi: " + str(put2xi) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                    
                    message2print = "{(Step 10d2/11) used" + "; job2xi-used-by-worker4xi: " + str(job2xi) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                    
                    message2print = "{(Step 10d3/11) used" + "; i2xi-used-by-worker4xi: " + str(i2xi) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                    
                    message2print = "{(Step 10d4/11) used" + "; result2xi-used-by-worker4xi: " + str(result2xi) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                except Exception as e:
                    wrapped2xi = None
                    try:
                        # =================================================
                        wrapped2xi = MaybeEncodingError4Xi(e, result2xi[1])
                        # =================================================
                        message2print = "{(Step 10z1/11) warned" + "; possible-encoding-error-warned-by-worker4xi: " + str(wrapped2xi) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        
                        # =================================================
                        put2xi((job2xi, i2xi, (False, wrapped2xi)))
                        # =================================================
                        
                        message2print = "{(Step 10z2/11) used" + "; job2xi-used-by-worker4xi: " + str(job2xi) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #  
                        message2print = "{(Step 10z3/11) used" + "; i2xi-used-by-worker4xi: " + str(i2xi) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                    except:            
                        message2print = "{(Step 10z4/11) failed" + "; wrapped2xi-failed-by-worker4xi: " + str(wrapped2xi) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
            else:
                nack2put = True
                
                message2print = "{(Step 10f/11) yielded" + "; nack2put-yielded-by-worker4xi: " + str(nack2put)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # 
                
            completed2xi += 1 
            message2print = "{(Step 10g/11) added" + "; completed2xi-added-by-worker4xi: " + str(completed2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #      
                             
    else:
        
        message2print = "{(Step 10b/11) yielded" + "; ack2while-yielded-by-worker4xi: " + str(ack2while)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        #                    
        
    #------------------------------------------------------------------------------------------
    # (Step 11/11) - RETURN
    #------------------------------------------------------------------------------------------
    try:
        message2print = "{(Step 10a/11) used" + "; job2xi-used-by-worker4xi: " + str(job2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        message2print = "{(Step 10b/11) used" + "; i2xi-used-by-worker4xi: " + str(i2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        message2print = "{(Step 10c/11) used" + "; func2xi-used-by-worker4xi: " + str(func2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        message2print = "{(Step 10d/11) used" + "; args-used-by-worker4xi: " + str(args)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        message2print = "{(Step 10e/11) used" + "; kwds-used-by-worker4xi: " + str(kwds)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        message2print = "{(Step 10f/11) used" + "; completed2xi-used-by-worker4xi: " + str(completed2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        message2print = "{(Step 10g/11) used" + "; put2xi-used-by-worker4xi: " + str(put2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        message2print = "{(Step 10h/11) used" + "; get2xi-used-by-worker4xi: " + str(get2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        message2print = "{(Step 10i/11) used" + "; wrapped2xi-used-by-worker4xi: " + str(wrapped2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        message2print = "{(Step 10j/11) used" + "; task2xi-used-by-worker4xi: " + str(task2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        message2print = "{(Step 10k/11) used" + "; maxtasks-used-by-worker4xi: " + str(maxtasks)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass
        
    message2print = "{(Step 11l/11) returning" + "; worker4xi-returning: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)      
    # NEVER COMES HERE ! - JATKA        
            
#</function4xi>
#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_ctypes_mp_xi4.py
#   test_math2_mp_xi4.py
#   test_pool1_mp_xi4.py
#   test_processref_mp_xi4.py
#   test_server_mp_xi4.py
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of worker4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
